{% extends 'base.html' %}
{% load  staticfiles %}

{% block content %}

{% if mensagem is not None %}
	<script>alert('{{mensagem}}')</script>
{% endif %}
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-
awesome/4.7.0/css/font-awesome.min.css">
<!-- Breadcrumbs-->
<ol class="breadcrumb">
	<li class="breadcrumb-item">
	<a href="realizar-consultas/">Início</a>
	</li>
	<li class="breadcrumb-item active">Gerar Relatórios</li>
</ol>


<div class="card-header" style="margin-bottom: 1%">
	<i class="fas fa-table"></i>
	Gerar Relatórios
</div>

<div class="container">
	<div id="lista_bancos" class="col mb-4" style="align-items: center	; justify-content: center; margin-left: 5%">
			<div class="form-group">
				<label for="banco" style="font-weight:bold;">Selecione um cliente:</label>
					<select style="align-self: center;" class="form-control" id="cliente" onchange="criaSelect()">
						<option value="0">----------------------</option>
						<option value="-1+-1">Todos os clientes</option>
						{% for cliente in clientes %}
							<option value="{{cliente.banco}}+{{cliente.conta}}">{{cliente.nome}} - {{cliente.conta}} - {{cliente.banco}}</option>
						{% endfor %}
					</select>
				</div>
				<div id="meses" class="form-group">
				</div>
	</div>
	<div class="col col-lg-6 offset-lg-3 col-md-8 offset-md-2 col-sm-12 col-xs-12 justify-content-center" id="dados">
	</div>
</div>

<p class="small text-center text-muted my-5">
	<em></em>
</p>

</div>
<!-- Modal -->
<!-- /.container-fluid -->
<script>
	$("search").bind("input", function(e) {
		while( $(this).outerWidth() < this.scrollHeight +
										parseFloat($(this).css("borderTopWidth")) +
										parseFloat($(this).css("borderBottomWidth"))
				&& $(this).width() < 50 // Altura máxima
		) {
			$(this).height($(this).height()+1);
		};
	});
</script>
<script type="text/javascript" src="{% static 'charts/js/jquery-3.4.1.min.js' %}"></script>
<!-- Bootstrap tooltips -->
<script type="text/javascript" src="{% static 'charts/js/popper.min.js' %}"></script>
<!-- Bootstrap core JavaScript -->
<script type="text/javascript" src="{% static 'charts/js/bootstrap.min.js' %}"></script>
<!-- MDB core JavaScript -->
<script type="text/javascript" src="{% static 'charts/js/mdb.js' %}"></script>
<!-- Bootstrap core JavaScript-->
<script src="{% static 'vendor/jquery/jquery.min.js' %}"></script>
<script src="{% static 'vendor/bootstrap/js/bootstrap.bundle.min.js' %}"></script>

<!-- Core plugin JavaScript-->
<script src="{% static 'vendor/jquery-easing/jquery.easing.min.js' %}"></script>

<script src="{% static 'vendor/datatables/jquery.dataTables.js' %}"></script>
<script src="{% static 'vendor/datatables/dataTables.bootstrap4.js' %}"></script>

<!-- Custom scripts for all pages-->
<script src="{% static 'js/sb-admin.min.js' %}"></script>
<script src="{% static 'js/demo/datatables-demo.js' %}"></script>
<!-- <script type="text/javascript" src="{% static 'js/jquery-3.4.1.min.js' %}"></script> -->
<!-- Bootstrap tooltips -->
<!-- <script type="text/javascript" src="{% static 'js/popper.min.js' %}"></script> -->
<!-- Bootstrap core JavaScript -->
<!-- <script type="text/javascript" src="{% static 'js/bootstrap.min.js' %}"></script> -->
<!-- MDB core JavaScript -->
<!-- <script type="text/javascript" src="{% static 'js/mdb.min.js' %}"></script> -->
<script>
	const dados = {{dados | safe}};
	let cliente = document.getElementById("cliente");
	let meses = document.getElementById("meses")
	let graficos = document.getElementById("dados");
	criaSelect = function() {
		const infos = cliente.value.split("+")
		var itens = $("div#meses").empty();
		var item = $("div#dados").empty();
		for(dado in dados){
			if(dados[dado].banco == infos[0] && dados[dado].conta == infos[1]) {
				let label = document.createElement("label");
				label.setAttribute("style", "align-self: center; font-weight: bold");
				label.setAttribute("class", "mr-4 mt-2")
				label.innerHTML = "Selecione um mês:"
				meses.appendChild(label)
				let select = document.createElement("select");
				let option = document.createElement("option");
				option.innerHTML = '-------'
				select.appendChild(option)
				for(vencimento in dados[dado].vencimentos) {
					let option = document.createElement("option")
					option.setAttribute("value", dados[dado].vencimentos[vencimento].referencia)
					option.innerHTML = dados[dado].vencimentos[vencimento].referencia
					select.appendChild(option)
				}
				select.setAttribute("onchange", "geraGraficos()")
				select.setAttribute("id", "mes")
				select.setAttribute("style", "align-self: center")
				select.setAttribute("class", "ml-1 form-control")
				meses.appendChild(select)
				break;
			}
		}
	}

	geraGraficos = function() {
		var itens = $("div#dados").empty();
		const referencia = document.getElementById("mes").value;
		let canvas = document.createElement("canvas")
		let div_grafico = document.createElement("div")
		div_grafico.setAttribute("class", " col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12 justify-content-center text-center")
		let div_dados = document.createElement("div")
		canvas.setAttribute("id", "doughnutChart")
		canvas.setAttribute("width", "100%")
		canvas.setAttribute("height", "100%")
		div_dados.setAttribute("class", "col")
		let texto = document.createElement("label")
		texto.setAttribute("id", "titulo")
		texto.setAttribute("style", "font-weight: bold")
		div_grafico.setAttribute("style", "justify-content: center; align-items: center;")
		div_grafico.appendChild(texto)
		div_grafico.appendChild(canvas)

		graficos.appendChild(div_grafico)

		var date = []
		var label = []
		var colores = []
		const infos = cliente.value.split("+")
		for(i = 0; i < dados.length; i ++) {
			if(dados[i].banco == infos[0] && dados[i].conta == infos[1]) {
				for(j = 0 ; j < dados[i].vencimentos.length; j++) {
					if(dados[i].vencimentos[j].referencia == referencia) {
						let texto = document.createElement("label")
						texto.innerHTML = "O lançamento com maior valor neste mês foi referente a compra: " + dados[i].vencimentos[j].maior_lancamento.descricao + ", com o valor: R$ " + (parseFloat(dados[i].vencimentos[j].maior_lancamento.valor).toFixed(2)).replace(".", ",") + "."
						texto.setAttribute("class", "text-center")
						div_dados.appendChild(texto)
						for(k = 0; k < dados[i].vencimentos[j].tags.length; k ++) {
							date.push(parseFloat(dados[i].vencimentos[j].tags[k].valor).toFixed(2))
							label.push(dados[i].vencimentos[j].tags[k].nome)
						}
						for(l = 0; l < label.length; l ++){
							const cor = gera_cor()
							if(cor in colores) {
								console.log("parae")
							} else {
								colores.push(cor)
							}
						}
						document.getElementById("titulo").innerHTML = "Gastos referentes ao mês " + referencia + " por tag."
						var ctxD = document.getElementById("doughnutChart").getContext('2d');
						var myLineChart = new Chart(ctxD, {
						type: 'doughnut',
						data: {
						labels: label,
						datasets: [{
						data: date,
						backgroundColor: colores,
						hoverBackgroundColor: colores,
						}]
						},
						options: {
						responsive: true
						}
						});
						graficos.appendChild(div_dados)
						break
					}
				}
			}
		}

	}
	function gera_cor(){
    	var hexadecimais = '0123456789ABCDEF';
    	var cor = '#';
  
    // Pega um número aleatório no array acima
    	for (var i = 0; i < 6; i++ ) {
    //E concatena à variável cor
        	cor += hexadecimais[Math.floor(Math.random() * 16)];
    	}
    	return cor;
	}
</script>
{% endblock %}